<?php
/*
Plugin Name: Chatbox
Plugin URI: http://nutomic.bplaced.net/chatbox
Description: A plugin that places a simple chatbox in your sidebar.
Version: 1.0
Author: Felix Ableitner
Author URI: http://nutomic.bplaced.net
License: GPL2


    Copyright 2010  Felix Ableitner  (email : felix.ableitner@web.de)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 2, as 
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
*/
class chatbox extends WP_Widget {

    function chatbox() { // widget actual processes
        parent::WP_Widget(false, $name = 'chatbox');	
    }

    function widget($args, $instance) {	// outputs the content of the widget

		$oldpost = '';

		if ( (isset($_POST['newpost']) ) and ( get_current_user_id ( ) != 0 ) and ( trim ( esc_attr ( $_POST ['newpost'] ) ) != '' ) ) { //save new post to database
			$newpost = trim(esc_attr($_POST['newpost']));
			if ( strlen ($newpost) > esc_attr($instance['length'])) $oldpost = esc_attr($_POST['newpost'] ); //post is too long
			
			else {
			
				for ( $i=1; $i<esc_attr( $instance['count'] ); $i++) { //add database if it doesnt exist
				
					if ( get_post_meta( esc_attr ( $instance['id'] ), "chatbox_user $i", 1 ) == '') {
						add_post_meta( esc_attr ( $instance['id'] ), "chatbox_user $i", "" );
						add_post_meta( esc_attr ( $instance['id'] ), "chatbox_post $i", "" );
					}
					
				}
				
				for ( $i=esc_attr ( $instance['count'] ); $i>1; $i-- ) {
					$j = $i - 1;
					update_post_meta ( esc_attr ( $instance['id'] ), "chatbox_user $i", get_post_meta( esc_attr($instance['id'] ), "chatbox_user $j", 1 ) ); //post_meta i-1 becomes post_meta i
					update_post_meta ( esc_attr ( $instance['id'] ), "chatbox_post $i", get_post_meta( esc_attr($instance['id'] ), "chatbox_post $j", 1 ) );
				}
				$done = 0;
				$offset = 0;
				$i = 0;
				$link = '';
				$newpost = $_POST['newpost'] . " ";
				while ( ! ($done) and ( $offset < strlen ( $newpost ) ) ) {//make links clickable
					$linkstart = strpos ( $newpost, "http://", $offset );
					if ( $linkstart !== false ) {
						$linkend = strpos ( $newpost, " ", $linkstart );
						$link = substr ( $newpost, $linkstart, ( $linkend - $linkstart ) );
						$newpost = str_replace ( $link, "<a href='$link'>$link</a>", $newpost );
						$offset += $linkstart + 15 + strlen ( $link ) * 2;
						$link = '';
						$i++;
					}
					else $done = 1;
				}
				$newpost = trim ( $newpost );
				update_post_meta ( esc_attr($instance['id'] ), "chatbox_user 1", get_current_user_id ( ) ); //post_meta 1 becomes current post and id
				update_post_meta ( esc_attr($instance['id'] ), "chatbox_post 1", $newpost ); 
			}
		}
		
		echo "<li id='chatbox-2' class='widget-container widget-chatbox' style='word-wrap:break-word'> \n 
				<h3 class='widget-title'>Chatbox</h3> \n
					<div class='chatbox-posts'> \n"; //echo widget title and div
					
		for ( $i=1; $i<esc_attr($instance['count'])+1; $i++) { //echo all posts...
			$user = get_post_meta ( esc_attr ( $instance['id'] ), "chatbox_user $i", 1 );
			$post = get_post_meta ( esc_attr ( $instance['id'] ), "chatbox_post $i", 1 );
			if ($post != '') { //...unless one doesnt yet exist
				$userdata = get_userdata ( $user );
				echo "<div class='chatbox_single'> \n
						<span class='chatbox-name'><b>" . $userdata->display_name . "</b></span>"; //echo the user name
			}
				elseif ($i == 1) {
					echo "No posts found.";
					break;
				}
				else break;
			if ($post != '') echo "<span class='chatbox-post'>: $post</span>
									</div>"; //echo the post
		}
		
		echo "	</div> \n";
		$userid = get_current_user_id ( );
		if ($userid == 0) echo "<a href='./wp-login.php'>Log in or register</a> to write to the chatbox. \n"; //sorry, you are not logged in
		
		else {
			echo   "<form id='chatbox' action='./' method='post'>\n
						 <input type='text' name='newpost' value='$oldpost'> \n
						<input type='submit' name='go' value='post'> \n
					</form> \n"; //echo the form
		}
		
		if ($oldpost != '') echo "Your post is too long. Maximum length is " . esc_attr($instance['length']) . " characters. <br> \n";
		echo "</li> \n";
    }
	
    function update($new_instance, $old_instance) {	// processes widget options to be saved
    return $new_instance;
    }

    function form($instance) { // outputs the options form on admin				
        $count = esc_attr(  $instance['count'] );
		if ( $count == '' ) $count = 5; //assigning default values
		$length = esc_attr ( $instance['length'] );
		if ( $length == '' ) $length = 100;
		$id = esc_attr ( $instance['id'] );
		if ( $id == '' ) $id = 1;
        ?>
            <p>
				<label for="<?php echo $this->get_field_id('count'); ?>">
					<?php _e('Number of messages to display:'); ?> 
					<input class="widefat" id="<?php echo $this->get_field_id('count'); ?>" name="<?php echo $this->get_field_name('count'); ?>" type="text" value="<?php echo $count; ?>" />
				</label>
				<label for="<?php echo $this->get_field_id('length'); ?>">
					<?php _e('Maximum message length in characters:'); ?> 
					<input class="widefat" id="<?php echo $this->get_field_id('length'); ?>" name="<?php echo $this->get_field_name('length'); ?>" type="text" value="<?php echo $length; ?>" />
				</label>
				<label for="<?php echo $this->get_field_id('id'); ?>">
					<?php _e('Enter any post id:'); ?> 
					<input class="widefat" id="<?php echo $this->get_field_id('id'); ?>" name="<?php echo $this->get_field_name('id'); ?>" type="text" value="<?php echo $id; ?>" />
					<?php _e('(this plugin saves chats in any posts metadata. leave "1" if a post with that id exists)'); ?> 
				</label>
        <?php 
    }

} // class Chatbox
add_action('widgets_init', create_function('', 'return register_widget("Chatbox");'));


?>
